/*
 * generated by Xtext
 */
package com.holycityaudio.spincad.generator

import org.eclipse.emf.ecore.resource.Resource
import org.eclipse.xtext.generator.IGenerator
import org.eclipse.xtext.generator.IFileSystemAccess
import com.holycityaudio.spincad.spinCADMenu.Menu
import com.holycityaudio.spincad.spinCADMenu.MENU_ITEM
import com.holycityaudio.spincad.spinCADMenu.MENU_HEADER
import com.holycityaudio.spincad.spinCADMenu.Element

/**
 * Generates code from your model files on save.
 * 
 * see http://www.eclipse.org/Xtext/documentation.html#TutorialCodeGeneration
 */
abstract class SpinCADMenuGenerator implements IGenerator {
	
	override void doGenerate(Resource resource, IFileSystemAccess fsa) {
		var pkage = "\\com\\holycityaudio\\SpinCAD\\"
		fsa.generateFile(pkage + resource.className+"Menu"+".java", toMenuCode(resource.contents.head as Menu))
		}
		
		def className(Resource res) {
			var name = res.URI.lastSegment
			println(name)
			return name.substring(0, name.indexOf('.'))
		}
	
	def toMenuCode(Menu mn) '''
		package com.holycityaudio.SpinCAD;
		import com.holycityaudio.SpinCAD.SpinCADBlock;
		import com.holycityaudio.SpinCAD.SpinCADPin;
		import com.holycityaudio.SpinCAD.fxblocks.basic.SpinFXBlock;
		«FOR Element m : mn.elements»
			«switch m {
				MENU_ITEM:{importMenuItem(m)}
			}»
		«ENDFOR»

		import java.awt.event.ActionEvent;
		import java.awt.event.ActionListener;
		
		import javax.swing.JMenu;
		import javax.swing.JMenuBar;
		import javax.swing.JMenuItem;
		import javax.swing.JPanel;
		
		
		public class «mn.eResource.className+"Menu"» {

		private static final long serialVersionUID = 1L;

		public «mn.eResource.className+"Menu"»(final SpinCADPanel panel, JMenuBar menuBar) {
	
		«val menuName = "testing"»
		«FOR Element m : mn.elements»
			«switch m {
				MENU_HEADER:{genMenu(m)}
				MENU_ITEM:{genMenuItem(m, menuName)}
			}»
		«ENDFOR»
		}
		'''

	def String genMenu(MENU_HEADER m) '''		
		«val menuNameX = "mn" + m.name.replaceAll("\\s+","")»
		JMenu «menuNameX» = new JMenu("«m.name»");
		menuBar.add(«menuNameX»);	
	'''

	def genMenuItem(MENU_ITEM m, String menuNameX) '''	
			
		final JMenuItem mntm«m.className» = new JMenuItem("«m.name»");
		mntm«m.className».addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				SpinCADBlock pcB = new «m.className»CADBlock(50, 100);
				dropBlock(panel, pcB);
			}
		});
		«menuNameX».add(mntm«m.className»);
			
'''

	def importMenuItem(MENU_ITEM m) '''		
		import com.holycityaudio.SpinCAD.CADBlocks.«m.className»CADBlock;
'''
}
